class CommonOptions:
    def __init__(self,
                 key: str = '',
                 authUrl: str = '',
                 refreshUrl: str = '',
                 revokeUrl: str = '',
                 authBody: dict = None,
                 authHeaders: dict = None,
                 authTokenName: str = '',
                 autoConnect: bool = True,
                 autoReconnect: bool = True,
                 autoAuthenticate: bool = True,
                 autoRefreshToken: bool = True,
                 refreshTokenInterval: int = 0,
                 autoSubscribeOnConnect: bool = True,
                 connectTimeout: int = 0,
                 ackTimeout: int = 0,
                 timestampRequests: bool = False,
                 timestampParam: str = '',
                 binaryType: str = '',
                 batchOnHandshake: bool = False,
                 batchOnHandshakeDuration: int = 0,
                 batchInterval: int = 0,
                 protocolVersion: int = 0,
                 wsOptions: dict = None,
                 cloneData: bool = False):
        self.key = key
        self.authUrl = authUrl
        self.refreshUrl = refreshUrl
        self.revokeUrl = revokeUrl
        self.authBody = authBody if authBody is not None else {}
        self.authHeaders = authHeaders if authHeaders is not None else {}
        self.authTokenName = authTokenName
        self.autoConnect = autoConnect
        self.autoReconnect = autoReconnect
        self.autoAuthenticate = autoAuthenticate
        self.autoRefreshToken = autoRefreshToken
        self.refreshTokenInterval = refreshTokenInterval
        self.autoSubscribeOnConnect = autoSubscribeOnConnect
        self.connectTimeout = connectTimeout
        self.ackTimeout = ackTimeout
        self.timestampRequests = timestampRequests
        self.timestampParam = timestampParam
        self.binaryType = binaryType
        self.batchOnHandshake = batchOnHandshake
        self.batchOnHandshakeDuration = batchOnHandshakeDuration
        self.batchInterval = batchInterval
        self.protocolVersion = protocolVersion
        self.wsOptions = wsOptions if wsOptions is not None else {}
        self.cloneData = cloneData
